<template>
  <code-mirror ref="cm" v-model="workspaceText" basic :tab-size="2" :dark="false" :gutter="true" :tab="true"
    :lang="lang" />
</template>

<script setup lang="ts">
// Add vue modules
import { ref } from "vue";
// import { type Ref, type PropType } from "vue";
import { watch, onMounted } from "vue";
// Adds components
// https://github.com/logue/vue-codemirror6
import CodeMirror from "vue-codemirror6";
// Adds js/ts components
import * as texteditor from '../core/texteditor'
import { WORKSPACE } from '../core/consts'

// props
const props = defineProps(['projects', 'index', 'update', 'activate', 'workspace']);
//emits
const emit = defineEmits(["content-cursor-index"]);

// Texto del workspace
const workspaceText = ref("");
// Referencia para cambiar el lenguaje de manera dinámica
const lang = ref();
// permite el uso de funciones del view de codemirror
const cm = ref();

// Mounted
// TODO: Antes este onmounted hacía uso de v-if, sin embargo, envista que se cambia
// de contexto, para el caso del codemirror se hara uso de v-show, así
// tardará menos en la ejcución (aunque requiera un poco más de memoria)
// pero será un proceso suave para el usuario.
// onMounted(() => {
//   lang.value = texteditor.setLang(props.projects[props.index].extension);
//   workspaceText.value = props.projects[props.index].content;
// });

// Watchers
// Este watcher facilita el intercambio de contenidos mientras que sea
// en el mismo contexto de codemirror, sin embargo, ahora se hace uso de v-show
// y para no ejecutar varios procesos en paralelo, en vista que se usa del mismo
// indice sin impor el contexto, se hará uso de un condicional que evite carga de
// procesos inecesarios
watch(() => [props.index, props.update], async () => {
  // Existen proyectos a cargar?
  if (props.projects.length > 0) {
    // update(newIndex, props.workspace);
    if (props.workspace == WORKSPACE.CODEMIRROR) {
      // Se ubica el cursor en la primera línea para que no genere errores
      // TODO: Se debe revisar el método getCursor para poder usar el metodo
      // setCursor desde la posición almacenada en proyectos, por ahora se fija
      // a la posición 0. (tener presente que la linea debe existir antes de poner
      // una posición)
      cm.value.setCursor(0);
      // Se cambia el lenguaje del editor según el proyecto
      lang.value = texteditor.setLang(props.projects[props.index].extension);
      // Se actualiza el contenido del editor
      workspaceText.value = props.projects[props.index].content;
    }
  }
})

// Estar atento a los cambios en el editor de texto
watch(workspaceText, (content) => {
  // Cuando se modifica el contenido, se emite el cambio junto al indice
  emit('content-cursor-index', content, cm.value.getCursor(), props.index);
});

</script>

<style scoped></style>
